//@STATE=作成中
//@DESCRIPTION ---------------------------------------------------------------
// EA01.h: EA01 クラスのインターフェイス
//	履歴：
// $Log: EA01.h,v $
// Revision 1.1  2001/10/28 21:40:35  fujiwara
// DLLに分割
//
// Revision 1.3  2001/07/09 20:30:08  fujiwara
// 例外処理の組み込み
//
// Revision 1.2  2001/07/01 01:03:43  fujiwara
// const の見直し
// 配置エディタは途中経過
//
// Revision 1.1  2001/06/03 09:21:49  fujiwara
// 地上敵クラスの追加
//
//@DESCRIPTION_END -----------------------------------------------------------
//@AUTHOR=S.F.
///////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_EA01_H__D088B903_844F_405A_8167_A0667765D4A8__INCLUDED_)
#define AFX_EA01_H__D088B903_844F_405A_8167_A0667765D4A8__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "AbstractEnemy.h"
namespace sf {
	namespace application {
		namespace enemy {

class EA01 : public AbstractEnemy
{
public:
	// LIFECYCLE //
	EA01();
	virtual ~EA01();
	// OPERATIONS //
	void initialize();
	// キャラクター移動
	void move(void);
	void hit(Character * const pDest);
	void allBomb(void);
	// テクスチャなどのロード
	static void load(void);
	static void unload(void);
	static Character * const create(float x,float y ,float z,sf::application::scene::Game * const pGame,int index);
	// ACCESS //
	sf::application::hit::Interface * const hitObj(void){return &mHitRect;};
private:
	enum State {
		MOVE,
		SHOOT,
		DEAD
	} mState;

	void die(void);

	int mDirCount;
	float mDirSpeed;
	sf::application::hit::HitRect mHitRect;
	sf::system::console::ObjRectangle mObj;
	sf::system::console::ObjRectangle mObjFoot;

	static sf::system::console::sprite::PSprite mspSprite[2];
	static const sf::system::console::sprite::Info msSpriteInfo[2];

	static const int SCORE; 
	
	bool mbHit;
	int mShootCount;
	int mShootTimer;
	float 	mDeltaTime;
	float 	mDeltaTimeRev;
	float mSpeed;
	float mDirBackup;
	int mAnimTimer;
	int mAnimSpeed;

};
		}
	}
}

#endif // !defined(AFX_EA01_H__D088B903_844F_405A_8167_A0667765D4A8__INCLUDED_)
